> For the complete documentation index, see [llms.txt](https://docs.zapsign.com.br/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.zapsign.com.br/zapsign-api/english/facilitators/sdks/java-sdk/documents-requests/createdocfromtemplateasync.md).

# createDocFromTemplateAsync

### Overview

Parameters:

* [DocFromTemplate](/zapsign-api/english/facilitators/sdks/java-sdk/used-classes/body/docfromtemplate.md)

Return:

* [DocAsyncResponse](/zapsign-api/english/facilitators/sdks/java-sdk/used-classes/response/docasyncresponse.md) - success
* Exception - failure

To create this document we need:

* set your api token.
* set your variables.
* set your doc.
* call the method.

### Usage:

Import the relevant components:

```java
import body.doc.DeParaTemplate;
import body.doc.DocFromTemplate;
import docs.DocRequests;
import response.DocAsyncResponse;

import services.JsonConverter;
import java.util.ArrayList;
```

Set your [Api Token](/zapsign-api/english/master.md):

```java
String apiToken = "YOUR TOKEN";
```

add your variables in a [DeParaTemplate ](/zapsign-api/english/facilitators/sdks/java-sdk/used-classes/body/deparatemplate.md)class list:

```java
DeParaTemplate deParaTemplateName = DeParaTemplate.deParaTemplateBuilder()
        .de("{{FULL NAME}}")
        .para("Full Name")
        .build();

DeParaTemplate deParaTemplateNumber= DeParaTemplate.deParaTemplateBuilder()
        .de("{{SOCIAL SECURITY NUMBER}}")
        .para("Social Security Number")
        .build();

DeParaTemplate deParaTemplateAddress = DeParaTemplate.deParaTemplateBuilder()
        .de("{{FULL ADDRESS}}")
        .para("Full address")
        .build();

ArrayList<DeParaTemplate> deParaTemplates = new ArrayList<>();
deParaTemplates.add(deParaTemplateName);
deParaTemplates.add(deParaTemplateCpf);
deParaTemplates.add(deParaTemplateEnd);
```

Set your doc with class with the class [DocFromTemplate](/zapsign-api/english/facilitators/sdks/java-sdk/used-classes/body/docfromtemplate.md):

```java
DocFromTemplate docFromTemplate = DocFromTemplate.docFromTemplateBuilder()
                .sandbox(false)
                .brand_primary_color("#000000")
                .lang("en")
                .signer_name("My Signer for template")
                .template_id("75a3a92b-...")
                .data(deParaTemplates)
                .build();
```

Call the method createDocFromTemplateAsync and receive the [DocAsyncResponse](/zapsign-api/english/facilitators/sdks/java-sdk/used-classes/response/docasyncresponse.md) class or an error message as a response:

```java
try {
    DocAsyncResponse docAsyncResponse = new DocRequests(apiToken).createDocFromTemplateAsync(docFromTemplate);
    String jsonDocResponse = new JsonConverter().docAsyncResponseToJson(docAsyncResponse);
    System.out.println(jsonDocResponse);
}
catch(Exception exceptionError) {
    System.out.println(exceptionError.getMessage());
}
```

### Example:

```java
import body.doc.DeParaTemplate;
import body.doc.DocFromTemplate;
import docs.DocRequests;
import response.DocResponse;
import services.JsonConverter;

import java.util.ArrayList;

public class CreateDocFromTemplate {
    public static void main(String[] args) throws Exception {
        String apiToken = "YOUR TOKEN";

        DeParaTemplate deParaTemplateName = DeParaTemplate.deParaTemplateBuilder()
                .de("{{FULL NAME}}")
                .para("Full Name")
                .build();
        
        DeParaTemplate deParaTemplateNumber= DeParaTemplate.deParaTemplateBuilder()
                .de("{{SOCIAL SECURITY NUMBER}}")
                .para("Social Security Number")
                .build();
        
        DeParaTemplate deParaTemplateAddress = DeParaTemplate.deParaTemplateBuilder()
                .de("{{FULL ADDRESS}}")
                .para("Full address")
                .build();

        ArrayList<DeParaTemplate> deParaTemplates = new ArrayList<>();
        deParaTemplates.add(deParaTemplateName);
        deParaTemplates.add(deParaTemplateCpf);
        deParaTemplates.add(deParaTemplateEnd);

        DocFromTemplate docFromTemplate = DocFromTemplate.docFromTemplateBuilder()
                .sandbox(false)
                .brand_primary_color("#000000")
                .lang("en")
                .signer_name("My Signer for template")
                .template_id("75a3a92b-36d5-451f-95cd-5af9a927a392")
                .data(deParaTemplates)
                .build();

        try {
            DocAsyncResponse docAsyncResponse = new DocRequests(apiToken).createDocFromTemplateAsync(docFromTemplate);
            String jsonDocResponse = new JsonConverter().docAsyncResponseToJson(docAsyncResponse);
            System.out.println(jsonDocResponse);
        }
        catch(Exception exceptionError) {
            System.out.println(exceptionError.getMessage());
        }
    }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.zapsign.com.br/zapsign-api/english/facilitators/sdks/java-sdk/documents-requests/createdocfromtemplateasync.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
